/* -----------------------------------------------------------------------------
 * (c) The GHC Team, 2002
 *
 * Things for functions.
 * ---------------------------------------------------------------------------*/

#ifndef STGFUN_H
#define STGFUN_H

/* generic - function comes with a small bitmap */
#define ARG_GEN      0   

/* generic - function comes with a large bitmap */
#define ARG_GEN_BIG  1

/* BCO - function is really a BCO */
#define ARG_BCO      2

/* specialised function types: bitmaps and calling sequences
 * for these functions are pre-generated (see ghc/utils/genapply), and
 * the generated code in ghc/rts/AutoApply.hc.
 *
 *  NOTE: this ordering/numbering is hard-coded into the tables
 *  generated by GenApply.hs which end up in AutoApply.cmm.
 */
#define ARG_N        3 
#define ARG_P        4 
#define ARG_F        5 
#define ARG_D        6 
#define ARG_L        7 
#define ARG_NN       8 
#define ARG_NP       9 
#define ARG_PN       10
#define ARG_PP       11
#define ARG_NNN      12
#define ARG_NNP      13
#define ARG_NPN      14
#define ARG_NPP      15
#define ARG_PNN      16
#define ARG_PNP      17
#define ARG_PPN      18
#define ARG_PPP      19
#define ARG_PPPP     20
#define ARG_PPPPP    21
#define ARG_PPPPPP   22
#define ARG_PPPPPPP  23
#define ARG_PPPPPPPP 24

#endif // STGFUN_H
